Summary: A server daemon with D-Bus interface providing a server roles
Name: rolekit
Version: 0.4.0.1
Release: 2%{?dist}
Url: https://github.com/libre-server/rolekit
License: GPLv2+
Source0: https://github.com/libre-server/rolekit/releases/download/rolekit-0_4_0/rolekit-%{version}.tar.bz2
BuildArch: noarch
BuildRequires: gettext
BuildRequires: intltool
# glib2-devel is needed for gsettings.m4
BuildRequires: glib2, glib2-devel, dbus-devel
BuildRequires: systemd-units
BuildRequires: docbook-style-xsl
BuildRequires: polkit-devel

BuildRequires: python3-devel
Requires: python3-dbus
Requires: python3-slip >= 0.6.4
Requires: python3-slip-dbus
Requires: python3-decorator

%if 0%{?fedora} >= 23
Requires: python3-gobject-base
%else
Requires: python3-gobject
%endif

Requires: python3-firewall
Requires: python-IPy-python3

Requires: firewalld
Requires: systemd
Requires: NetworkManager
Requires: dnf
Requires: polkit
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

# == Patches == #
Patch0001: 0001-MAN-Fix-incorrect-argument-to-rolectl.patch

%description
rolekit is a server daemon that provides a D-Bus interface and server roles.


%prep
%setup -q
%patch0001 -p1

%build
%configure

%install
%{__mkdir_p} $RPM_BUILD_ROOT/%{_datadir}/bash-completion/completions
make install DESTDIR=%{buildroot}

# Move the testrole into documentation instead of the live system
%{__mkdir_p} $RPM_BUILD_ROOT/%{_docdir}/examples/
%{__mv} $RPM_BUILD_ROOT/%{_prefix}/lib/rolekit/roles/testrole \
        $RPM_BUILD_ROOT/%{_docdir}/examples/


#%find_lang %{name} --all-name

%post
%systemd_post rolekit.service

%preun
%systemd_preun rolekit.service

%postun
%systemd_postun_with_restart rolekit.service


#%files -f %{name}.lang
%files
%doc COPYING README.md
%{_sbindir}/roled
%{_bindir}/rolectl
%defattr(-,root,root)
%dir %{_sysconfdir}/rolekit
%dir %{_sysconfdir}/rolekit/roles
%dir %{_sysconfdir}/rolekit/deferredroles
%dir %{_prefix}/lib/rolekit
%dir %{_prefix}/lib/rolekit/roles
%{_prefix}/lib/rolekit/roles/domaincontroller/*.py*

%{_prefix}/lib/rolekit/roles/databaseserver/*.py*
%{_prefix}/lib/rolekit/roles/databaseserver/tools/rk_db_setpwd.py*

%{_prefix}/lib/rolekit/roles/memcache/*.py*

%config(noreplace) %{_sysconfdir}/sysconfig/rolekit
%{_unitdir}/rolekit.service
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/rolekit1.conf
%{_datadir}/polkit-1/actions/org.fedoraproject.rolekit1.policy
%{_datadir}/dbus-1/system-services/org.fedoraproject.rolekit1.service
%attr(0755,root,root) %dir %{python3_sitelib}/rolekit
%attr(0755,root,root) %dir %{python3_sitelib}/rolekit/config
%attr(0755,root,root) %dir %{python3_sitelib}/rolekit/server
%attr(0755,root,root) %dir %{python3_sitelib}/rolekit/server/io
%{python3_sitelib}/rolekit/*.py*
%{python3_sitelib}/rolekit/config/*.py*
%{python3_sitelib}/rolekit/rolectl/*.py*
%{python3_sitelib}/rolekit/server/*.py*
%{python3_sitelib}/rolekit/server/io/*.py*

%{python3_sitelib}/rolekit/config/__pycache__/*.py*
%{python3_sitelib}/rolekit/__pycache__/*.py*
%{python3_sitelib}/rolekit/rolectl/__pycache__/*.py*
%{python3_sitelib}/rolekit/server/__pycache__/*.py*
%{python3_sitelib}/rolekit/server/io/__pycache__/*.py*

%{_mandir}/man1/role*.1*
%{_mandir}/man5/role*.5*
%{_docdir}/examples/

%dir %{_datadir}/bash-completion/completions
%{_datadir}/bash-completion/completions/rolectl


%changelog
* Wed Oct 14 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0.1-2
- Fix manpage reference to --deferred option

* Wed Oct 07 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0.1-1
- New upstream release 0.4.0.1
- Fix a single serious crash bug

* Mon Sep 28 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0-5
- Release version 0.4.0
- Drop upstreamed patches
- https://github.com/libre-server/rolekit/releases/tag/rolekit-0_4_0

* Thu Sep 03 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0-4.rc1
- Fix permissions on role JSON settings files to avoid leaking sensitive info

* Wed Sep 02 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0-3.rc1
- Added support for installing roles through kickstart
- Added support for providing setting values through stdin
- Enabled deploying Domain Controller and Database Server with no mandatory
  options
- New API feature: sanitize() which will remove sensitive information from the
  settings output (such as autogenerated passwords once they have been
  recorded)

* Wed Jul 22 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0-2.beta1
- Add memcache role

* Thu Jul 09 2015 Stephen Gallagher <sgallagh@redhat.com> 0.4.0.alpha1
- Switch to python3
- Add support for older versions of postgresql

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Apr 07 2015 Stephen Gallagher <sgallagh@redhat.com> 0.3.2-1
- Fix bug with setting database owner password

* Tue Mar 31 2015 Stephen Gallagher <sgallagh@redhat.com> 0.3.1-1
- Don't create an instance on input value failure
- DB Role: don't consider ERROR instances when checking for first-instance
  deployment.

* Thu Mar 26 2015 Stephen Gallagher <sgallagh@redhat.com> 0.3.0-1
- Support for the Database Server Role
- New verbose option for 'rolectl list instances'
- Manpage cleanups

* Mon Feb 23 2015 Stephen Gallagher <sgallagh@redhat.com> 0.2.2-1
- Switch to DNF for package management

* Mon Feb 23 2015 Stephen Gallagher <sgallagh@redhat.com> 0.2.1-2
- Add missing dependency on python2-firewall

* Fri Feb 20 2015 Stephen Gallagher <sgallagh@redhat.com> 0.2.1-1
- New Database Server Role
- Enhancements to async.py for impersonation and passing stdin

* Mon Nov 17 2014 Stephen Gallagher <sgallagh@redhat.com> 0.1.2-1
- Allow role plugins to offer multiple instances.
- No longer leaves an instance behind if setting validation fails.
- Doc enhancements.
- Drop upstreamed documentation patch.

* Fri Nov 07 2014 Stephen Gallagher <sgallagh@redhat.com> 0.1.1-2
- Add some more docs

* Thu Nov 06 2014 Stephen Gallagher <sgallagh@redhat.com> 0.1.1-1
- Improved documentation
- Added bash-completion support for rolectl
- Input validation for the Domain Controller role
- Numerous bug fixes

* Mon Oct 13 2014 Stephen Gallagher <sgallagh@redhat.com> 0.1.0-2
- Handle service failures detected by systemd

* Mon Oct 13 2014 Thomas Woerner <twoerner@redhat.com> 0.1.0-1
- Update role instance state on roled wakup.
- New package and group installation during role deployment
- RoleBase: Use systemd targets for start() and stop()
- New support for systemd targets
- RoleBase: Handle NULL types
- Domain Controller: Export properties
- Added missing requires for firewalld, systemd, NetworkManager and yum
- New --settings-file option for rolectl, replaces --set option
- New firewall handling
- Property fixes, new property checks
- Bug fixes

* Fri Aug 22 2014 Thomas Woerner <twoerner@redhat.com> 0.0.3-1
- Domain Controller: Add decommission routine
- Better trapping of non-ASCII output on subprocess
- Domain Controller deployment
- Make decommission asynchronous
- Improve exception logging
- DBusRole: New method get_name, using in RoleD.getNamedRole
- Enable logging of subprocess output
- Implement starting and stopping services, and use it in databaseserver
- New async.async_subprocess_future helper
- Changed async naming conventions
- Convert exceptions in D-Bus methods in async methods
- Added missing resetError message
- Several fixes and cleanups

* Mon Aug 11 2014 Thomas Woerner <twoerner@redhat.com> 0.0.2-1
- new instance support
- new rolectl command line tool
- new redeploy feature for instances
- new async support for deploy, start and stop D-Bus methods
- finalized states
- adapted D-Bus interface for instances
- dbus activation and auto-termination after some inactivity time
- dbus exception handling fixes
- build fixes and cleanups (distcheck, po/Makefile.in.in, ..)
- several fixes and cleanups

* Fri May 23 2014 Thomas Woerner <twoerner@redhat.com> 0.0.1-1
- initial package (proof of concept implementation)
